*:*****************************************************************************
*:
*: Procedure file: ASCROLL.PRG
*:
*:         Author: Jo W. French, dba Practical Computing
*:                 CIS ID: 74730, 1751
*:      Copyright (c) 1995, by the Author. Placed in the public domain.
*:
*:  Procs & Fncts: MAIN()
*:               : TMPGETMAKE()
*:               : DEFINEGETS()
*:               : FILLGETLIST()
*:               : DEFINESAYS()
*:
*:  Revision 1.01: 03-06-95 Added Paging. Changed Line scroll to Ctrl_Up/Down.
*:                 Added nPos increment to 'fix' 5.2 When bug.
*:           1.02: 03-07-95 Fixed bug in PgDn algorithm and simplified.
*:
*:        Compile: /n /w
*:*****************************************************************************

#include "inkey.ch"
#include "getexit.ch"
#define APTR	  oTb:CARGO[1] 	// Pointer
#define ATOP	  oTb:CARGO[2] 	// TOP Limit
#define ABOT	  oTb:CARGO[3] 	// BOTTOM Limit
#define ATOPROW  oTb:CARGO[4] 	// TOP BROWSE SCREEN ROW
#define DOWNKEYS  CHR( K_CTRL_DOWN ) + CHR( K_DOWN ) + CHR( K_ENTER )
#define UPKEYS    CHR( K_CTRL_UP ) + CHR( K_UP )

*!*****************************************************************************
*!
*!       Function: MAIN()
*!
*!       Example of scrolling SAY's and  GETS using Clipper's
*!       Get, TBrowse and TBcolumn classes.
*!*****************************************************************************
FUNCTION Main()
   LOCAL aSay, oTb, oCol, nKey := 0, nTmp, nPos, cSave := SETCOLOR()
   LOCAL aGets, i, GetList := {}, oGet
	LOCAL aTmpGets := {}
	SET SCOREBOARD OFF
   SETBLINK( .F. )

   READEXIT( .T. )       // Up/Dn Arrows as Exit Keys.
	SETKEY( K_F10, 		{|| GetActive():ExitState := GE_ESCAPE } )
   SETKEY( K_CTRL_DOWN, {|| GetActive():ExitState := GE_ESCAPE } )
   SETKEY( K_CTRL_UP  , {|| GetActive():ExitState := GE_ESCAPE } )
   SETKEY( K_CTRL_PGUP, {|| GetActive():ExitState := GE_ESCAPE } )
   SETKEY( K_CTRL_PGDN, {|| GetActive():ExitState := GE_ESCAPE } )

   DefineGets( @aGets )               // Initialize an array of variables.
   FillGetList( Getlist, aGets )      // Specify the Gets.
   DefineSays( @aSay )                // Specify the Says.
	CLS

	/* Set Up Browse for SAYs.*/
   @  4, 0 TO 19, 79 DOUBLE           // Box
	oTb			:= TBROWSENEW( 5, 1, 18, 78 )
   oTb:COLORSPEC := "W+/B, B/W"
	oTb:HEADSEP := ""
	oTb:FOOTSEP := ""

	oTb:CARGO := ARRAY(4)
	APTR		 := 1
	ATOP		 := 1
	ABOT		 := LEN(aSay)

	oTb:GOTOPBLOCK 	:= { || APTR := ATOP }
	oTb:GOBOTTOMBLOCK := { || APTR := ABOT }
	oTb:SKIPBLOCK		:= {|nReq| -APTR + ;
                        (APTR := MAX( ATOP, MIN( ABOT, APTR + nReq) ) ) }
	oTb:AUTOLITE		:= .F.

	oCol :=	TBCOLUMNNEW( "", { || aSay[APTR] } )
	oCol:HEADING := PADC( "This is a Scrolling Gets Demo.", 78 )
	oCol:FOOTING := ;
   PADC( "Ctrl_Up/Down Scrolls One Line. Ctrl_PgUp/PgDn to Top/Bottom.", 78 )+";"+;
   PADC( "PgUp/PgDown  Scrolls One Page. F10 / Esc.  will end editing.", 78 )
	oTb:ADDCOLUMN(oCol)

	oTb:FORCESTABLE()
	ATOPROW := ROW()

	TmpGetMake( GetList, @aTmpGets, 1, oTb )

	nPos := 1
   WHILE !( CHR( LASTKEY() ) $ CHR( K_ESC ) + CHR( K_F10 ) )
      oGet := aTmpGets[nPos]
      IF oGet:preblock != NIL .AND. !EVAL( oGet:preblock, oGet )
         /* This condition may be removed if 5.2's GetSys.prg has
         *  been modified to correct the bug in the Settle function
         *  re' entering ReadModal with a false WHEN condition.
         */
         IF nPos++ > LEN( aTmpGets )
            nPos :=1
         ENDIF
         LOOP
      ELSE
         READMODAL( aTmpGets, nPos )
      ENDIF
      nKey := LASTKEY()
		DO CASE
         CASE CHR( nKey ) $ DOWNKEYS .AND. APTR < ABOT
				oTb:ROWPOS := oTb:ROWCOUNT
				oTb:DOWN()
				oTb:FORCESTABLE()
            nTmp := APTR - oTb:ROWPOS + 1
            TmpGetMake( GetList, @aTmpGets, nTmp, oTb )
				nTmp	:= ATAIL( aTmpGets ):ROW
				nPos	:= LEN( aTmpGets )
            WHILE aTmpGets[nPos]:ROW == nTmp  ; nPos-- ; END
				nPos ++
         CASE CHR( nKey ) $ UPKEYS .AND. APTR > 1
				oTb:ROWPOS := 1
				oTb:UP()
				oTb:FORCESTABLE()
            nTmp := APTR - oTb:ROWPOS + 1
            TmpGetMake( GetList, @aTmpGets, nTmp, oTb )
				nPos := 1
         CASE nKey == K_CTRL_PGUP .AND. APTR > 1
            oTb:GOTOP()
            oTb:FORCESTABLE()
            nTmp := 1
            TmpGetMake( GetList, @aTmpGets, nTmp, oTb )
            nPos := 1
         CASE nKey == K_CTRL_PGDN .AND. APTR < ABOT
            oTb:GOBOTTOM()
            oTb:FORCESTABLE()
            nTmp  := ABOT - oTb:rowcount + 1
            TmpGetMake( GetList, @aTmpGets, nTmp, oTb )
            nPos := 1
         CASE CHR( nKey ) $ DOWNKEYS .AND. APTR == ABOT
            nTmp  := ATAIL( aTmpGets ):ROW
            nPos  := LEN( aTmpGets )
            WHILE aTmpGets[nPos]:ROW == nTmp ; nPos-- ; END
            nPos ++
         CASE nKey == K_PGUP .AND. APTR > 1
            oTb:ROWPOS := 1
            oTb:PAGEUP()
            oTb:FORCESTABLE()
            nTmp := APTR - oTb:ROWPOS + 1
            TmpGetMake( GetList, @aTmpGets, nTmp, oTb )
            nPos := 1
         CASE nKey == K_PGDN .AND. APTR < ABOT
            oTb:ROWPOS := oTb:ROWCOUNT
            oTb:PAGEDOWN()
            oTb:FORCESTABLE()
            nTmp := APTR - oTb:ROWPOS + 1
            TmpGetMake( GetList, @aTmpGets, nTmp, oTb )
            nPos := 1
      ENDCASE
   END
   SETBLINK( .T. )
   SETCOLOR( cSave )
   CLS
RETURN NIL

*!*****************************************************************************
*!
*!       Function: TMPGETMAKE()
*!       Extracts a portion of the GetList for reading.
*!*****************************************************************************
FUNCTION TmpGetMake( GetList, aTmpGets, nPtr, oTb )
	LOCAL i, nTmp
	aTmpGets := {}
	FOR i := 1 TO LEN( GetList )
		nTmp := GetList[i]:CARGO
      IF nTmp >= nPtr .and. nTmp <= nPtr + oTb:ROWCOUNT - 1
			AADD( aTmpGets, GetList[i] )
			ATAIL( aTmpGets ):ROW := nTmp - nPtr + ATOPROW
		ENDIF
	NEXT
	DISPBEGIN()
		AEVAL( aTmpGets, {|o|o:DISPLAY()} )
	DISPEND()
RETURN NIL

*!*****************************************************************************
*!
*!       Function: DEFINEGETS()
*!       Initial array of get data. Could be from a SCATTER function.
*!*****************************************************************************
FUNCTION DefineGets( aGets )
	LOCAL i
   aGets     := ARRAY( 45 )
   AFILL( aGets, SPACE(19) )
   aGets[ 1] := "French              "
   aGets[ 2] := "Jo             "
   aGets[ 3] := "W"
   aGets[ 4] := CTOD("")
   aGets[ 5] := SPACE(11)
   aGets[ 6] := "M"
   aGets[43] := SPACE(67)
   aGets[44] := SPACE(56)
   aGets[45] := "74730, 1751"
RETURN NIL

*!*****************************************************************************
*!
*!       Function: FILLGETLIST()
*!
*!       Prepares the Master GetList array of Get objects. Could use GetNew().
*!       NOTE: Initial GET Rows are relative to the TBROWSE window.
*!*****************************************************************************
FUNCTION FillGetList( Getlist, aGets )
   /* NOTE: Initial Get Rows are relative to the TBrowse window. */
   LOCAL i, nTmp
	DISPBEGIN()
      @  1, 13 GET aGets[ 1]
      @  1, 48 GET aGets[ 2]
      @  1, 74 GET aGets[ 3] PICTURE "@!R X."
      @  2, 17 GET aGets[ 4]
      @  2, 48 GET aGets[ 5] PICTURE "999-99-9999"
      @  2, 74 GET aGets[ 6] PICTURE "!"
		nTmp := 6
      FOR i := 4 TO 23
         IF !( i == 10 .OR. i == 17 )
            @  i, 20 GET aGets[++nTmp]
            @  i, 59 GET aGets[++nTmp]
         ENDIF
      NEXT
      @ 25, 11 GET aGets[43]
      @ 26,  2 GET aGets[44]
      @ 26, 67 GET aGets[45]
		CLS
	DISPEND()
   AEVAL( GetList, {|o| o:CARGO := o:ROW, o:COLORSPEC := "R+/GR*, G/W*" } )
RETURN NIL

FUNCTION DefineSays( aSay )
   /* Suggestion: Store in .dbf. */
   aSay := ARRAY( 27 )
	aSay[ 1] := " Last Name:                       First Name:"+;
					"                   Initial:  .   "
	aSay[ 2] := " Date of Birth:            Social Security #:"+;
					"     -  -              Sex:      "
	aSay[ 3] := "****************************** DOS Programs *"+;
					"*********************************"
   aSay[ 4] := " dBase Program  1:                     "+;
               " dBase Program  2:                     "
   aSay[ 5] := " WordProcessor  1:                     "+;
               " WordProcessor  2:                     "
   aSay[ 6] := " SpreadSheet    1:                     "+;
               " SpreadSheet    2:                     "
   aSay[ 7] := " Prog.Language  1:                     "+;
               " Prog.Language  2:                     "
   aSay[ 8] := " Communications 1:                     "+;
               " Communications 2:                     "
   aSay[ 9] := " Miscellaneous  1:                     "+;
               " Miscellaneous  2:                     "
	aSay[10] := "************************** Windows Programs *"+;
					"*********************************"
   aSay[11] := " dBase Program  1:                     "+;
               " dBase Program  2:                     "
   aSay[12] := " WordProcessor  1:                     "+;
               " WordProcessor  2:                     "
   aSay[13] := " SpreadSheet    1:                     "+;
               " SpreadSheet    2:                     "
   aSay[14] := " Prog.Language  1:                     "+;
               " Prog.Language  2:                     "
   aSay[15] := " Communications 1:                     "+;
               " Communications 2:                     "
   aSay[16] := " Miscellaneous  1:                     "+;
               " Miscellaneous  2:                     "
   aSay[17] := "***************************** OS/2 Programs *"+;
					"*********************************"
   aSay[18] := " dBase Program  1:                     "+;
               " dBase Program  2:                     "
   aSay[19] := " WordProcessor  1:                     "+;
               " WordProcessor  2:                     "
   aSay[20] := " SpreadSheet    1:                     "+;
               " SpreadSheet    2:                     "
   aSay[21] := " Prog.Language  1:                     "+;
               " Prog.Language  2:                     "
   aSay[22] := " Communications 1:                     "+;
               " Communications 2:                     "
   aSay[23] := " Miscellaneous  1:                     "+;
               " Miscellaneous  2:                     "
   aSay[24] := "***************************************"+;
               "***************************************"
   aSay[25] := " Remarks:                              "+;
               "                                       "
   aSay[26] := "                                       "+;
               "                   CIS ID:             "
   aSay[27] := "***************************************"+;
               "***************************************"
RETURN NIL

*: EOF: ASCROLL.PRG
